
import Acquisition
import AccessControl, DocumentTemplate
import OFS
from Globals import HTMLFile, MessageDialog, Persistent
from Shared.DC.ZRDB.Aqueduct import custom_default_report
import regex, regsub, string, urllib
try:
    from PILGraph import *
except:
    pass
import StringIO, operator, DateTime, re
UnableToRender = "Unable to render graph with this method"


def u_l(old, rev=0):
    """ remove duplicates from a list. keep order. if rev=1, keep last 
	occurance, not first """
    if rev:
	old.reverse()
    nd={}
    new = len(old) * [None]
    cnt = 0
    for e in old:
        if e:
            try:
                nd[e]
            except:
                nd[e] = e
                new[cnt] = e
                cnt = cnt + 1
    new = new[:cnt]
    if rev:
	new.reverse()
    return new

class DMC_nonP(
    Acquisition.Implicit,
    AccessControl.Role.RoleManager,
    OFS.SimpleItem.Item,
    ):
    " a data mining constraint  - non persistant version"

    icon = 'misc_/DMC/dmc'
    meta_type = 'DMC'

    manage_options = (
        {'label':'Settings', 'action':'manage_main'},
        {'label':'Security', 'action':'manage_access'},
    )
    __ac_permissions__ = (
        ('Edit Data Mining Constraint', ('manage_settings','manage_main', 'manage_access', )),
        ('Use Data Mining Constraint',('', 'index_html', 'fix', 'show', 'showplain', 'showcsv', 'showgraph' )),
    )

    def __init__(self, id, shortname):
	self.isaDataMiner = 1
	self.id = id
	self.title = shortname
	self.shortname = shortname
	self.select_col_clause = ""
	self.select_tab_clause = ""
	self.where_clause = ""
	self.where_constraint = ""
	self.group_by_clause = ""
	self.sqltype = "string"
	self.parent = None

    manage_main = HTMLFile('dmcMain', globals())
    ResultForm = HTMLFile('dmcResult', globals())

    def fix(self):
	"fix me up"
	return "foo"

    def getjoins(self,tablist):
	if len(tablist) < 2:
	    return [], []
	joins = [] ; addn_tables = []
	try:
	    joinsQ = self.joins
	except: 
	    raise "JoinError", "Couldn't find 'joins' object"
	for i in tablist:
	    for j in tablist:
		#print "i,j",i,j
		if i != j:
		    res = joinsQ(atable=i,btable=j)
		    #print "res", res, len(res)
		    if len(res):
			joins.append(res[0].joinstr)
			#print "a",res[0].addn_tables
			addn_tables.append(res[0].addn_tables)
		    else:
			res = joinsQ(atable=j,btable=i)
			#print "rres", res, len(res)
			if len(res):
			    joins.append(res[0].joinstr)
			    #print "a",res[0].addn_tables
			    addn_tables.append(res[0].addn_tables)
			else:
			    raise "Can't Join", "%s to %s"%(i,j)
	return u_l(joins), filter(None, u_l(addn_tables))

    def manage_settings(self, REQUEST, shortname, 
	select_col_clause, select_tab_clause, 
	where_clause, group_by_clause, sqltype):
	" load new settings "

	self.shortname = shortname
	if group_by_clause and len(group_by_clause):
	    self.title = "group by: %s"%shortname 
	else:
	    self.title = "add data: %s"%shortname 
	self.select_col_clause = select_col_clause 
	self.select_tab_clause = select_tab_clause
	self.where_clause = where_clause
	self.group_by_clause = group_by_clause
	self.sqltype = sqltype

	return MessageDialog(
            title = 'settings changed',
            message = 'dmc has been changed',
            action = REQUEST['URL1']+'/manage_main',
            target = 'manage_main')

    def __bobo_traverse__(self, REQUEST, name=None):
	" traversal. gosh. scary. "
	if hasattr(self,name):
	    return getattr(self,name)
	if name[:2] == "op":
	    return self.clone(op=name)

    def clone(self, op):
	" doc "
	# BUG. assigning to self.new causes the changed .new to be written
	# to the ZODB. But if I don't, it won't #&$#*$ acquire anything.
	self._v_new = DMC_nonP(urllib.quote(op, safe='_'), self.title)
	#self.realid = self.id
	op = op[2:] # chop the leading 'op'
	self._v_new.isaDataMiner = 1
	self._v_new.select_col_clause = ""
	self._v_new.select_tab_clause = self.select_tab_clause 
	self._v_new.where_clause = self.where_clause 
	self._v_new.shortname = self.shortname 
	self._v_new.group_by_clause = ""  #self.group_by_clause 
	self._v_new.sqltype = self.sqltype 
	sqlop = ""
	if op[:2]=="eq":
	    sqlop = "="
	if op[:2]=="ne":
	    sqlop = "!="
	if op[:2]=="gt":
	    sqlop = ">"
	if op[:2]=="ge":
	    sqlop = ">="
	if op[:2]=="lt":
	    sqlop = "<"
	if op[:2]=="le":
	    sqlop = "<="
	if sqlop:
	    arg = op[2:]
	    self._v_new.title = "(where %s %s %s)"%(self.shortname, sqlop, arg)
	    if self._v_new.sqltype == "string":
		arg = "'%s'"%(arg)  # sql_quote this!
	    if self.group_by_clause:
		self._v_new.where_constraint = "%s %s %s"%(self.where_clause, sqlop, arg)
	    else:
		self._v_new.having_constraint = "%s %s %s"%(self.where_clause, sqlop, arg)
		self._v_new.where_constraint = ""
	    return self._v_new
	else:
	    return None

    def find_constraints(self):
        objs = []
        p = self
        while 1:
            if hasattr(p, 'aq_parent'): 
		p = p.aq_parent
		if not hasattr(p, 'isaDataMiner'): 
		    break
            else: 
		p = None
		break
	# p is now the container for the constraints.
	if hasattr(p, 'objectValues'):
	    for o in p.objectValues():
		if hasattr(o, 'isaDataMiner'):
		    objs.append(o)
	objs.sort(dmc_sorter)
        return objs

    def extract_callchain(self, allobs=0):
        objs = []
        p = self
        while 1:
	    if hasattr(p, 'id'):
		if allobs:
		    if hasattr(p, 'realid'): i = p.realid
		    else: i = p.id
		    a = p.absolute_url()
		    objs.append({'object':p, 'realid':i, 'obURL':a })
		else:
		    objs.append(p)
	    # if we're a constraining object, skip past one.
	    if hasattr(p, 'where_constraint') and len(p.where_constraint):
		if allobs: objs.append({})
		p = p.aq_parent
            if hasattr(p, 'aq_parent'): 
		p = p.aq_parent
		if not hasattr(p, 'isaDataMiner'): 
		    break
            else: 
		break
	objs.reverse()
        return objs

    def _renderSQL(self):
        import string
        objs = self.extract_callchain()
        select_columns = u_l(map(lambda x:x.select_col_clause, objs), rev=1)
        select_tables = u_l(map(lambda x:x.select_tab_clause, objs))
        where_joins, add_tabs = self.getjoins(select_tables)
	select_tables = u_l(select_tables + add_tabs )
        havings = u_l(map(lambda x:(len(x.group_by_clause) and x.where_constraint) or "", objs))
        havings = havings + u_l(map(lambda x:hasattr(x, 'having_constraint') and x.having_constraint, objs))
        wheres = u_l(map(lambda x:(len(x.group_by_clause) and "") or x.where_constraint, objs))
        group_bys = u_l(map(lambda x:x.group_by_clause, objs), rev=1)
        
	#print wheres, havings, group_bys
	wheres = filter(lambda x:x and len(x), wheres)
	havings = filter(lambda x:x and len(x), havings)
        st = ["SELECT\n"]
        st.append(string.join(select_columns, ",\n"))
        st.append("\n FROM \n")
        st.append(string.join(select_tables, ", "))

        if len(wheres) or len(where_joins):
            st.append("\n WHERE \n")
	    if len(where_joins):
		st.append(string.join(where_joins, " and\n"))
            if len(wheres) and len(where_joins):
                st.append("\n AND\n")
            st.append(string.join(wheres, " and\n"))

        if len(group_bys):
            st.append("\n GROUP BY\n")
            st.append(string.join(group_bys, ", "))

        if len(havings):
            st.append("\n HAVING \n")
            st.append(string.join(havings, " and\n"))

        cmd = string.join(st, "")
	#print cmd
	return cmd

    def do_query(self, REQUEST):
	" perform the query "
	cmd = self._renderSQL()
	if hasattr(self, 'datasql'):
	    datasql = getattr(self, 'datasql')
	else:
	    if hasattr(self, 'parent') and hasattr(self.parent, 'datasql'):
		datasql = getattr(self.parent, 'datasql')
	    else:
		raise "DataError", "couldn't find datasql!"
	REQUEST.set('command', cmd)
	return datasql(REQUEST)

    def showcsv(self, REQUEST, editable=1):
	" show stuff, in csv form "
	results = self.do_query(REQUEST)
	r = custom_csv_output(self.id, results)
	rep = DocumentTemplate.HTML(r)
	rep = apply(rep, (self, REQUEST), {self.id:results})
	resp = REQUEST.RESPONSE
	resp.setHeader("Content-type", "text/plain")
	return rep

    def showplain(self, REQUEST):
	" show stuff, without edit tabs "
	return self.show(REQUEST, editable=0)

    def show(self, REQUEST, editable=1):
	" show stuff "
	results = self.do_query(REQUEST)
	r = custom_html_output(self.id, results, editable)
	Results = self.ResultForm
	Results = apply(Results, (self, REQUEST), 
		 {  'results' : r,
		    'src' : REQUEST['command'],
		    'callchain': self.extract_callchain(allobs=1),
		    'constraintslist': self.find_constraints(),
		    'editable': editable } )
	rep = DocumentTemplate.HTML(Results)
	rep = apply(rep, (self, REQUEST), {self.id:results})
	return rep

    def showgraph(self, REQUEST):
	" not yet "
	results = self.do_query(REQUEST)
	return self.do_graph(results)

    def do_graph(self, query):
	#gmeths = ( 'do_linegraph_date', 'do_piechart', 'do_barchart' )
	gmeths = ( 'do_linegraph_date', )
	graph = None
	for gmeth in gmeths:
	    try:
		graph = getattr(self,gmeth)(query)
	    except UnableToRender:
		graph = None
	    if graph is not None:
		break
	if graph is None:
	    raise UnableToRender, "unable to render graph"
	graph.render()
	out = StringIO.StringIO()
	graph.image.save(out, 'png')
	req = self.REQUEST
	resp = req.RESPONSE
	resp.setHeader("Content-type", "image/png")
	return out.getvalue()

    def do_linegraph_date(self, query):
	dcache = {}
	cols = query._searchable_result_columns()[:]
	datename_pat = re.compile("[Dd][Aa][Tt][Ee]")

	for c in range(len(cols)):
	    xname = cols[c]['name']
	    if datename_pat.match ( xname ) != -1:
		xvals = u_l(map (lambda x, n=xname:getattr(x, n), query))
		xvals, dcache = makedates(xvals, dcache) 
		if xvals is not None:
		    break
	if xvals is None:
	    raise UnableToRender, "couldn't find a date column"
	del cols[c]

	y1type = cols[0]['type']
	#print "y1type = ",y1type
	if y1type in ( 's', 't' ):
	    graph = LineGraph('P', (400,200), 0)
	    # schema is date, group, result
	    grps_d = {}
	    groupname = cols[0]['name']
	    # extract set of all group names.
	    map ( lambda x, gn=groupname, d=grps_d, set=operator.setitem: 
			set(d,getattr(x,gn), 1), query )
	    grps = grps_d.keys()
	    grps.sort()

	    #print cols, grps
	    for g in grps:
		dn = cols[1]['name'] # data name
		qvals = filter(lambda x, gn=groupname, g=g: getattr(x,gn) == g, query)
		yvals = map(lambda x, dn=dn: (hasattr(x,dn) and getattr(x,dn)), qvals)
		txvals = map(lambda x, xn=xname: getattr(x,xn), qvals)
		txvals, dcache = makedates(txvals, dcache)

		yvals = map (lambda v:(v is not None and v) or 0, yvals)
		real_yvals = [0]*len(xvals)
		# now fill in the empty points. #?*@#$+$%!
		i = 0 ; j = 0
		while ( i < len(xvals) ):
		    if j < len(txvals) and xvals[i] == txvals[j]:
			real_yvals[i] = yvals[j]
			i=i+1 ; j=j+1
		    else:
			real_yvals[i] = 0
			i=i+1 
			
		graph.add_dataset(g, xvals, real_yvals)
		graph.add_decoration(YLabel(cols[1]['name']))
	    if len(grps) > 1:
		graph.add_decoration(DataLabels())
	else:
	    graph = LineGraph('P', (400,200), 0)
	    for y in cols[:]:
		y = y['name']
		yvals = map (lambda x, n=y:getattr(x, n), query)
		#print "yname =",y
		#print "len(yvals) =", len(yvals)
		#print "yvals =", yvals
		yvals = map (lambda v:(v is not None and v) or 0, yvals)
		#print "yvals =", yvals
		graph.add_dataset(y, xvals, yvals)
	    if len(cols) == 1:
		graph.add_decoration(YLabel(y))
	    else:
		graph.add_decoration(DataLabels())

	graph.add_decoration(XTickDates())
	graph.add_decoration(XLabel(xname))
	graph.add_decoration(
		    YTickValues(FloatValues(align='right'), mod_steps=1))
	return graph

    index_html = show

class DMC ( Persistent, DMC_nonP ):
    " persisent class . same as DMC. "
    pass

addDMCForm = HTMLFile('dmcAdd', globals())

def addDMC(self, id, shortname, REQUEST=None):
    """Create a DMC and install it in the parent folder"""

    dmc = DMC(id, shortname)
    self._setObject(id, dmc)
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

def P(p):
    if hasattr(p, 'id'):
	if type(p.id) is type(""):
	    return "%s, %s"%(`p`, p.id) 
	else:
	    return "%s, %s"%(`p`, p.id()) 
    else:
	return "%s, %s"%(`p`, 'no id')

def custom_html_output(id, res, editable):
    import string
    cols = res._searchable_result_columns()
    topbit = ["<!-- %s --><table border>\n<tr>"%id]
    inbit = ["\n<!--#in \"_['%s']\"-->\n <tr>\n"%id]
    
    for c in cols:
	topbit.append("<th>%s</th>"%nicify(c['name']))
	if c['type'] in ('s', 't'):
	    inbit.append('  <td><!--#var %s --></td>\n'%c['name'])
	else:
	    inbit.append('  <td><!--#var %s null="0.0" --></td>\n'%c['name'])
    if editable and id[:2] != 'op':
	topbit.append("<th>select constraint<br>(column `%s')</th>"%c['name'])
	inbit.append("  <td>")
	for op in ( "eq", "ne", "le", "lt", "ge", "gt" ):
	    inbit.append(
             '  <a href="<!--#var URL1-->/op%s<!--#var %s url_quote-->/<!--#var id-->/show">%s</a>\n' %
		(op, c['name'], op))
	inbit.append("  </td>")
    inbit.append(" </tr>\n<!--#/in-->")
    out = topbit + inbit
    out.append("</tr>\n</table>")
    out = string.join(out, '')
    #print out
    return out

def custom_csv_output(id, res):
    import string
    cols = res._searchable_result_columns()
    topbit = [""]
    inbit = ["<!--#in \"_['%s']\"-->"%id]
    for c in cols:
	topbit.append('"%s",' % nicify(c['name']))
	if c['type'] in ('s', 't'):
	    inbit.append('"<!--#var %s -->",' % c['name'])
	else:
	    inbit.append('<!--#var %s null="0.0" -->,' % c['name'])
    inbit.append("\n<!--#/in-->")
    topbit.append("\n")
    out = topbit + inbit
    out = string.join(out, '')
    #print out
    return out

def nicify(name, under=regex.compile('_')):
    name=regsub.gsub(under,' ',string.strip(name))
    return string.upper(name[:1])+name[1:]

def makedates(xvals, cache=None):
    from DateTime import DateTime
    if cache is None:
	cache = {}
    out = [0]*len(xvals)
    for i in range(len(xvals)):
	if cache.has_key(xvals[i]):
	    out[i] = cache[xvals[i]]
	else:
	    try:
		d = DateTime(xvals[i])
	    except:
		return None, None
	    out[i] = int(d)
	    cache[xvals[i]] = int(d)
    return out, cache

def complex_getjoin_helper(res):
    return [ ( ( res.atable, res.btable ), res.joinstr ), 
             ( ( res.btable, res.atable ), res.joinstr )  ]

def complex_getjoin(qobj, i, j):
    " unfinished. graph stuff for joins . "
    nodes = [] 
    nodes = nodes + map ( complex_getjoin_helper, qobj(atable=i) )
    nodes = nodes + map ( complex_getjoin_helper, qobj(btable=i) )
    nodes = nodes + map ( complex_getjoin_helper, qobj(atable=j) )
    nodes = nodes + map ( complex_getjoin_helper, qobj(btable=j) )
    for n in nodes:
	pass

def dmc_sorter(a,b):
    return cmp(a.shortname, b.shortname)
