-- example schema for sample data mine application.
-- this assumes Oracle sqlplus SQL command termination - that is, an
-- interactive SQL command is terminated with ';'. 
-- other db tools, such as sqsh and isql, want 'go', instead.

-- this is a _totally_ brutally stupid schema, but it allows me
-- to show off a lot of the features.

--drop table ex_groups
--;
--drop table ex_accounts
--;
--drop table ex_billing
--;

create table ex_groups (
    group_id int PRIMARY KEY,
    group_name char(10)
) 
; 

create table ex_accounts (
    account_id	int PRIMARY KEY,
    account	char(10),		-- account id
    group_id	int			-- ref into ex_groups
)
;

create table ex_billing (
    billing_id  int PRIMARY KEY,
    account_id	int,
    edate	char(10), 		-- event date as yyyy-mm-dd
    quantity	int, 			-- number of minutes
    rate	float,  		-- rate per minute
    amount	float 			-- total value of call
)
;

insert into ex_groups values ( 1, 'Staff' )
;
insert into ex_groups values ( 2, 'Clowns' )
;
insert into ex_groups values ( 3, 'Cust01' )
;
insert into ex_groups values ( 4, 'Cust02' )
;

insert into ex_accounts values ( 1, '8888888801', 1 )
;
insert into ex_accounts values ( 2, '8888888802', 1 )
;
insert into ex_accounts values ( 3, '8888888803', 1 )
;
insert into ex_accounts values ( 4, '8888888804', 1 )
;
insert into ex_accounts values ( 5, '8888888805', 1 )
;
insert into ex_accounts values ( 6, '8888888806', 4 )
;
insert into ex_accounts values ( 7, '9000000001', 3 )
;
insert into ex_accounts values ( 8, '9000000002', 4 )
;
insert into ex_accounts values ( 9, '9000000003', 3 )
;
insert into ex_accounts values ( 10, '9000000004', 3 )
;
insert into ex_accounts values ( 11, '9000000005', 3 )
;
insert into ex_accounts values ( 12, '9000000006', 3 )
;
insert into ex_accounts values ( 13, '9000000007', 4 )
;
insert into ex_accounts values ( 14, '9000000008', 3 )
;
insert into ex_accounts values ( 15, '9000000009', 4 )
;
insert into ex_accounts values ( 16, '9000000010', 4 )
;
insert into ex_accounts values ( 17, '9000000011', 4 )
;
insert into ex_accounts values ( 18, '9000000012', 4 )
;
insert into ex_accounts values ( 19, '6060606060', 2 )
;

insert into ex_billing values ( 1, 1, '1999-05-23', 6, 2.350, 15.14 )
;
insert into ex_billing values ( 2, 17, '1999-05-23', 9, 0.550, 5.08 )
;
insert into ex_billing values ( 3, 6, '1999-05-23', 6, 2.350, 16.29 )
;
insert into ex_billing values ( 4, 5, '1999-05-23', 0, 0.550, 0.04 )
;
insert into ex_billing values ( 5, 2, '1999-05-23', 3, 0.560, 1.93 )
;
insert into ex_billing values ( 6, 11, '1999-05-23', 8, 1.040, 9.22 )
;
insert into ex_billing values ( 7, 14, '1999-05-24', 8, 0.550, 4.53 )
;
insert into ex_billing values ( 8, 19, '1999-05-24', 1, 0.670, 1.04 )
;
insert into ex_billing values ( 9, 19, '1999-05-24', 9, 0.270, 2.46 )
;
insert into ex_billing values ( 10, 8, '1999-05-24', 1, 0.550, 0.85 )
;
insert into ex_billing values ( 11, 19, '1999-05-24', 5, 0.550, 2.80 )
;
insert into ex_billing values ( 12, 8, '1999-05-24', 3, 0.270, 1.08 )
;
insert into ex_billing values ( 13, 16, '1999-05-24', 8, 0.560, 4.76 )
;
insert into ex_billing values ( 14, 19, '1999-05-24', 8, 1.040, 8.77 )
;
insert into ex_billing values ( 15, 11, '1999-05-24', 9, 0.270, 2.58 )
;
insert into ex_billing values ( 16, 14, '1999-05-24', 9, 0.550, 5.10 )
;
insert into ex_billing values ( 17, 16, '1999-05-24', 5, 2.350, 13.17 )
;
insert into ex_billing values ( 18, 1, '1999-05-25', 4, 0.270, 1.25 )
;
insert into ex_billing values ( 19, 19, '1999-05-25', 2, 0.560, 1.43 )
;
insert into ex_billing values ( 20, 1, '1999-05-25', 2, 0.670, 1.99 )
;
insert into ex_billing values ( 21, 5, '1999-05-25', 9, 0.670, 6.57 )
;
insert into ex_billing values ( 22, 16, '1999-05-25', 0, 0.550, 0.01 )
;
insert into ex_billing values ( 23, 19, '1999-05-25', 8, 0.350, 2.99 )
;
insert into ex_billing values ( 24, 5, '1999-05-25', 5, 0.350, 1.84 )
;
insert into ex_billing values ( 25, 5, '1999-05-25', 4, 0.670, 2.90 )
;
insert into ex_billing values ( 26, 5, '1999-05-25', 8, 2.350, 20.68 )
;
insert into ex_billing values ( 27, 17, '1999-05-25', 6, 0.350, 2.38 )
;
insert into ex_billing values ( 28, 16, '1999-05-25', 9, 0.350, 3.39 )
;
insert into ex_billing values ( 29, 5, '1999-05-25', 9, 1.040, 10.00 )
;
insert into ex_billing values ( 30, 14, '1999-05-25', 9, 1.040, 10.32 )
;
insert into ex_billing values ( 31, 14, '1999-05-25', 5, 0.560, 3.08 )
;
insert into ex_billing values ( 32, 14, '1999-05-25', 0, 1.040, 0.02 )
;
insert into ex_billing values ( 33, 2, '1999-05-26', 7, 0.550, 3.94 )
;
insert into ex_billing values ( 34, 17, '1999-05-26', 9, 0.350, 3.32 )
;
insert into ex_billing values ( 35, 19, '1999-05-26', 6, 2.350, 15.89 )
;
insert into ex_billing values ( 36, 19, '1999-05-26', 2, 0.270, 0.58 )
;
insert into ex_billing values ( 37, 11, '1999-05-26', 9, 0.560, 5.07 )
;
insert into ex_billing values ( 38, 11, '1999-05-26', 9, 0.670, 6.49 )
;
insert into ex_billing values ( 39, 8, '1999-05-26', 3, 0.270, 0.94 )
;
insert into ex_billing values ( 40, 17, '1999-05-26', 9, 0.350, 3.50 )
;
insert into ex_billing values ( 41, 17, '1999-05-26', 3, 2.350, 9.00 )
;
insert into ex_billing values ( 42, 7, '1999-05-26', 6, 1.040, 6.67 )
;
insert into ex_billing values ( 43, 8, '1999-05-26', 4, 0.560, 2.32 )
;
insert into ex_billing values ( 44, 10, '1999-05-26', 3, 2.350, 7.74 )
;
insert into ex_billing values ( 45, 16, '1999-05-26', 7, 0.560, 4.41 )
;
insert into ex_billing values ( 46, 2, '1999-05-26', 1, 0.270, 0.38 )
;
insert into ex_billing values ( 47, 17, '1999-05-26', 0, 0.270, 0.22 )
;
insert into ex_billing values ( 48, 17, '1999-05-27', 2, 0.560, 1.48 )
;
insert into ex_billing values ( 49, 16, '1999-05-27', 6, 0.560, 3.51 )
;
insert into ex_billing values ( 50, 8, '1999-05-27', 9, 0.560, 5.60 )
;
insert into ex_billing values ( 51, 11, '1999-05-27', 1, 0.560, 0.99 )
;
insert into ex_billing values ( 52, 15, '1999-05-27', 5, 0.670, 3.99 )
;
insert into ex_billing values ( 53, 19, '1999-05-27', 7, 0.560, 4.19 )
;
insert into ex_billing values ( 54, 11, '1999-05-27', 6, 0.550, 3.74 )
;
insert into ex_billing values ( 55, 10, '1999-05-27', 9, 1.040, 10.31 )
;
insert into ex_billing values ( 56, 2, '1999-05-27', 6, 0.270, 1.66 )
;
insert into ex_billing values ( 57, 19, '1999-05-27', 7, 0.270, 1.98 )
;
insert into ex_billing values ( 58, 16, '1999-05-27', 0, 1.040, 0.13 )
;
insert into ex_billing values ( 59, 15, '1999-05-27', 4, 0.560, 2.66 )
;
insert into ex_billing values ( 60, 17, '1999-05-27', 9, 0.670, 6.69 )
;
insert into ex_billing values ( 61, 8, '1999-05-27', 7, 0.560, 4.43 )
;
insert into ex_billing values ( 62, 10, '1999-05-28', 9, 0.350, 3.50 )
;
insert into ex_billing values ( 63, 19, '1999-05-28', 9, 0.560, 5.44 )
;
insert into ex_billing values ( 64, 7, '1999-05-28', 8, 2.350, 20.11 )
;
insert into ex_billing values ( 65, 15, '1999-05-28', 8, 2.350, 19.79 )
;
insert into ex_billing values ( 66, 8, '1999-05-28', 9, 0.560, 5.54 )
;
insert into ex_billing values ( 67, 16, '1999-05-28', 8, 0.550, 4.94 )
;
insert into ex_billing values ( 68, 10, '1999-05-28', 7, 0.550, 4.38 )
;
insert into ex_billing values ( 69, 11, '1999-05-28', 7, 0.270, 2.08 )
;
insert into ex_billing values ( 70, 2, '1999-05-28', 7, 0.670, 5.27 )
;
insert into ex_billing values ( 71, 8, '1999-05-28', 5, 0.560, 3.06 )
;
insert into ex_billing values ( 72, 14, '1999-05-28', 2, 0.350, 0.91 )
;
insert into ex_billing values ( 73, 8, '1999-05-28', 9, 0.350, 3.36 )
;
insert into ex_billing values ( 74, 17, '1999-05-28', 9, 0.670, 6.21 )
;
insert into ex_billing values ( 75, 17, '1999-05-28', 0, 0.270, 0.08 )
;
insert into ex_billing values ( 76, 8, '1999-05-28', 8, 0.670, 5.38 )
;
insert into ex_billing values ( 77, 15, '1999-05-28', 7, 0.550, 3.86 )
;
insert into ex_billing values ( 78, 19, '1999-05-28', 3, 2.350, 7.37 )
;
insert into ex_billing values ( 79, 16, '1999-05-28', 2, 0.350, 1.03 )
;
insert into ex_billing values ( 80, 8, '1999-05-28', 9, 0.670, 6.55 )
;
insert into ex_billing values ( 81, 8, '1999-05-28', 0, 0.550, 0.42 )
;
insert into ex_billing values ( 82, 2, '1999-05-28', 8, 1.040, 9.20 )
;
insert into ex_billing values ( 83, 19, '1999-05-29', 9, 0.670, 6.54 )
;
insert into ex_billing values ( 84, 19, '1999-05-29', 2, 1.040, 2.56 )
;
insert into ex_billing values ( 85, 19, '1999-05-29', 8, 0.670, 6.00 )
;
insert into ex_billing values ( 86, 19, '1999-05-29', 9, 0.560, 5.26 )
;
insert into ex_billing values ( 87, 19, '1999-05-29', 4, 2.350, 9.75 )
;
insert into ex_billing values ( 88, 19, '1999-05-29', 6, 2.350, 14.65 )
;
insert into ex_billing values ( 89, 14, '1999-05-29', 4, 1.040, 4.37 )
;
insert into ex_billing values ( 90, 13, '1999-05-29', 5, 1.040, 5.43 )
;
insert into ex_billing values ( 91, 11, '1999-05-29', 4, 0.670, 3.21 )
;
insert into ex_billing values ( 92, 17, '1999-05-29', 8, 1.040, 9.25 )
;
insert into ex_billing values ( 93, 8, '1999-05-29', 9, 2.350, 21.71 )
;
insert into ex_billing values ( 94, 8, '1999-05-29', 9, 2.350, 22.50 )
;
insert into ex_billing values ( 95, 11, '1999-05-29', 5, 2.350, 13.73 )
;
insert into ex_billing values ( 96, 11, '1999-05-29', 4, 0.560, 2.27 )
;
insert into ex_billing values ( 97, 11, '1999-05-29', 2, 2.350, 6.72 )
;
insert into ex_billing values ( 98, 11, '1999-05-29', 9, 0.270, 2.59 )
;
insert into ex_billing values ( 99, 11, '1999-05-29', 2, 0.670, 1.54 )
;
insert into ex_billing values ( 101, 17, '1999-05-29', 9, 1.040, 9.91 )
;
insert into ex_billing values ( 102, 2, '1999-05-29', 2, 0.270, 0.75 )
;
insert into ex_billing values ( 103, 14, '1999-05-29', 0, 0.550, 0.52 )
;
insert into ex_billing values ( 104, 7, '1999-05-29', 7, 0.350, 2.76 )
;
insert into ex_billing values ( 105, 14, '1999-05-29', 5, 0.550, 2.89 )
;
insert into ex_billing values ( 106, 16, '1999-05-29', 2, 0.550, 1.65 )
;
insert into ex_billing values ( 107, 14, '1999-05-29', 6, 0.560, 3.72 )
;
insert into ex_billing values ( 108, 19, '1999-05-29', 8, 0.670, 5.50 )
;
insert into ex_billing values ( 109, 11, '1999-05-30', 6, 2.350, 14.99 )
;
insert into ex_billing values ( 110, 17, '1999-05-30', 2, 2.350, 6.18 )
;
insert into ex_billing values ( 111, 11, '1999-05-30', 4, 0.550, 2.62 )
;
insert into ex_billing values ( 112, 10, '1999-05-30', 5, 0.350, 2.08 )
;
insert into ex_billing values ( 113, 19, '1999-05-30', 9, 0.550, 5.09 )
;
insert into ex_billing values ( 114, 2, '1999-05-30', 7, 0.670, 5.04 )
;
insert into ex_billing values ( 115, 19, '1999-05-30', 5, 0.670, 3.90 )
;
insert into ex_billing values ( 116, 17, '1999-05-30', 9, 0.350, 3.46 )
;
insert into ex_billing values ( 117, 15, '1999-05-30', 9, 0.670, 6.64 )
;
insert into ex_billing values ( 118, 19, '1999-05-30', 7, 0.550, 4.18 )
;
insert into ex_billing values ( 119, 14, '1999-05-30', 4, 0.350, 1.75 )
;
insert into ex_billing values ( 120, 16, '1999-05-30', 9, 0.670, 6.49 )
;
insert into ex_billing values ( 121, 11, '1999-05-30', 0, 0.670, 0.16 )
;
insert into ex_billing values ( 122, 11, '1999-05-30', 0, 0.670, 0.18 )
;
insert into ex_billing values ( 123, 11, '1999-05-30', 7, 0.560, 4.36 )
;
insert into ex_billing values ( 124, 15, '1999-05-30', 9, 0.350, 3.44 )
;
insert into ex_billing values ( 125, 2, '1999-05-31', 6, 2.350, 15.21 )
;
insert into ex_billing values ( 126, 8, '1999-05-31', 1, 0.270, 0.36 )
;
insert into ex_billing values ( 127, 8, '1999-05-31', 9, 2.350, 21.39 )
;
insert into ex_billing values ( 128, 14, '1999-05-31', 9, 1.040, 10.40 )
;
insert into ex_billing values ( 129, 10, '1999-05-31', 2, 2.350, 4.72 )
;
insert into ex_billing values ( 130, 11, '1999-05-31', 9, 0.270, 2.66 )
;
insert into ex_billing values ( 131, 17, '1999-05-31', 7, 1.040, 8.17 )
;
insert into ex_billing values ( 132, 8, '1999-05-31', 3, 0.550, 1.85 )
;
insert into ex_billing values ( 133, 7, '1999-05-31', 9, 0.550, 5.16 )
;
insert into ex_billing values ( 134, 17, '1999-06-01', 1, 0.270, 0.51 )
;
insert into ex_billing values ( 135, 16, '1999-06-01', 8, 2.350, 20.48 )
;
insert into ex_billing values ( 136, 8, '1999-06-01', 7, 0.560, 4.13 )
;
insert into ex_billing values ( 137, 8, '1999-06-01', 9, 0.550, 5.42 )
;
insert into ex_billing values ( 138, 19, '1999-06-01', 6, 0.670, 4.61 )
;
insert into ex_billing values ( 139, 8, '1999-06-01', 6, 0.560, 3.46 )
;
insert into ex_billing values ( 140, 17, '1999-06-01', 9, 0.550, 5.29 )
;
insert into ex_billing values ( 141, 19, '1999-06-01', 4, 1.040, 4.61 )
;
insert into ex_billing values ( 142, 10, '1999-06-01', 5, 0.560, 3.34 )
;
insert into ex_billing values ( 143, 11, '1999-06-01', 9, 0.560, 5.15 )
;
insert into ex_billing values ( 144, 15, '1999-06-01', 6, 0.350, 2.22 )
;
insert into ex_billing values ( 145, 17, '1999-06-01', 6, 2.350, 15.61 )
;
insert into ex_billing values ( 146, 16, '1999-06-01', 3, 1.040, 3.27 )
;
insert into ex_billing values ( 147, 7, '1999-06-01', 4, 0.670, 3.10 )
;
insert into ex_billing values ( 148, 19, '1999-06-01', 6, 0.670, 4.61 )
;
insert into ex_billing values ( 149, 11, '1999-06-02', 9, 0.350, 3.42 )
;
insert into ex_billing values ( 150, 14, '1999-06-02', 4, 1.040, 4.72 )
;
insert into ex_billing values ( 151, 16, '1999-06-02', 7, 0.350, 2.68 )
;
insert into ex_billing values ( 152, 19, '1999-06-02', 5, 0.270, 1.47 )
;
insert into ex_billing values ( 153, 17, '1999-06-02', 3, 2.350, 8.76 )
;
insert into ex_billing values ( 154, 8, '1999-06-02', 4, 0.670, 2.76 )
;
insert into ex_billing values ( 155, 16, '1999-06-02', 1, 0.550, 0.88 )
;
insert into ex_billing values ( 156, 11, '1999-06-02', 0, 0.560, 0.41 )
;
insert into ex_billing values ( 157, 10, '1999-06-02', 9, 0.550, 5.27 )
;
insert into ex_billing values ( 158, 16, '1999-06-02', 0, 0.270, 0.11 )
;
insert into ex_billing values ( 159, 7, '1999-06-02', 6, 0.670, 4.67 )
;
insert into ex_billing values ( 160, 10, '1999-06-02', 5, 2.350, 11.96 )
;
insert into ex_billing values ( 161, 2, '1999-06-02', 6, 0.350, 2.15 )
;
insert into ex_billing values ( 162, 15, '1999-06-02', 7, 1.040, 7.70 )
;
insert into ex_billing values ( 163, 14, '1999-06-02', 0, 0.270, 0.17 )
;
insert into ex_billing values ( 164, 17, '1999-06-02', 7, 2.350, 18.26 )
;
insert into ex_billing values ( 165, 19, '1999-06-03', 3, 0.670, 2.39 )
;
insert into ex_billing values ( 166, 8, '1999-06-03', 7, 2.350, 18.32 )
;
insert into ex_billing values ( 167, 16, '1999-06-03', 4, 0.560, 2.24 )
;
insert into ex_billing values ( 168, 19, '1999-06-03', 9, 0.550, 5.37 )
;
insert into ex_billing values ( 169, 2, '1999-06-03', 8, 0.670, 5.70 )
;
insert into ex_billing values ( 170, 8, '1999-06-03', 3, 0.270, 0.86 )
;
insert into ex_billing values ( 171, 7, '1999-06-03', 9, 2.350, 23.22 )
;
insert into ex_billing values ( 172, 2, '1999-06-03', 7, 0.560, 4.34 )
;
insert into ex_billing values ( 173, 7, '1999-06-03', 6, 0.550, 3.56 )
;
insert into ex_billing values ( 174, 8, '1999-06-03', 5, 0.270, 1.36 )
;
insert into ex_billing values ( 175, 16, '1999-06-03', 6, 2.350, 15.21 )
;
insert into ex_billing values ( 176, 3, '1999-06-03', 0, 0.270, 0.04 )
;
insert into ex_billing values ( 177, 16, '1999-06-03', 6, 1.040, 7.09 )
;
insert into ex_billing values ( 178, 14, '1999-06-03', 8, 0.670, 5.78 )
;
insert into ex_billing values ( 179, 3, '1999-06-03', 6, 0.550, 3.53 )
;
insert into ex_billing values ( 180, 11, '1999-06-03', 1, 2.350, 3.33 )
;
insert into ex_billing values ( 181, 15, '1999-06-03', 0, 0.350, 0.25 )
;
insert into ex_billing values ( 182, 11, '1999-06-04', 0, 0.560, 0.45 )
;
insert into ex_billing values ( 183, 14, '1999-06-04', 6, 0.350, 2.10 )
;
insert into ex_billing values ( 184, 3, '1999-06-04', 8, 0.670, 5.59 )
;
insert into ex_billing values ( 185, 11, '1999-06-04', 7, 0.270, 1.92 )
;
insert into ex_billing values ( 186, 3, '1999-06-04', 5, 0.550, 3.28 )
;
insert into ex_billing values ( 187, 17, '1999-06-04', 7, 2.350, 17.53 )
;
insert into ex_billing values ( 188, 3, '1999-06-04', 8, 1.040, 8.38 )
;
insert into ex_billing values ( 189, 2, '1999-06-04', 3, 0.560, 2.11 )
;
insert into ex_billing values ( 190, 10, '1999-06-04', 8, 1.040, 9.27 )
;
insert into ex_billing values ( 191, 3, '1999-06-04', 7, 0.670, 5.07 )
;
insert into ex_billing values ( 192, 10, '1999-06-04', 2, 0.270, 0.72 )
;
insert into ex_billing values ( 193, 17, '1999-06-04', 3, 0.560, 1.74 )
;
insert into ex_billing values ( 194, 10, '1999-06-04', 9, 2.350, 23.44 )
;
insert into ex_billing values ( 195, 10, '1999-06-04', 2, 0.560, 1.46 )
;
insert into ex_billing values ( 196, 2, '1999-06-04', 4, 2.350, 9.96 )
;
insert into ex_billing values ( 197, 2, '1999-06-04', 3, 1.040, 3.72 )
;
insert into ex_billing values ( 198, 17, '1999-06-04', 9, 0.270, 2.68 )
;
insert into ex_billing values ( 199, 14, '1999-06-04', 4, 0.350, 1.66 )
;
